From 85373e15ae76199b84c8fa54a03599348b0c14aa Mon Sep 17 00:00:00 2001
From: Nicolas ROCHE <nroche@entrouvert.com>
Date: Tue, 26 Nov 2019 14:38:35 +0100
Subject: [PATCH] add theme for saint-denis (#38353)

---
 static/saint-denis/_custom.scss             | 156 ++++++++++++++++++++
 static/saint-denis/_vars.scss               |  29 ++++
 static/saint-denis/config.json              |   6 +
 static/saint-denis/img/footer-fond.png      | Bin 0 -> 1529 bytes
 static/saint-denis/img/logo-saint-denis.png | Bin 0 -> 13005 bytes
 static/saint-denis/style.scss               |   5 +
 6 files changed, 196 insertions(+)
 create mode 100644 static/saint-denis/_custom.scss
 create mode 100644 static/saint-denis/_vars.scss
 create mode 100644 static/saint-denis/config.json
 create mode 100644 static/saint-denis/img/footer-fond.png
 create mode 100644 static/saint-denis/img/logo-saint-denis.png
 create mode 100644 static/saint-denis/style.scss

diff --git a/static/saint-denis/_custom.scss b/static/saint-denis/_custom.scss
new file mode 100644
index 00000000..83d116df
--- /dev/null
+++ b/static/saint-denis/_custom.scss
@@ -0,0 +1,156 @@
+@import '../includes/font-notosans';
+
+div#header-wrapper {
+    div#header {
+		padding-left: 0;
+		h1 {
+			padding-top: 30px;
+			a {
+				display: block;
+				height: 103px;
+				background: url(img/logo-saint-denis.png) top left no-repeat;
+				width: 250px;
+			}
+		}
+	}
+}
+
+div.gru-nav-wrapper {
+	background: $secondary-color;
+}
+
+div.gru-nav {
+	font-size: 22px;
+	ul {
+		padding-top: 10px;
+		margin-bottom: 5px;
+		li ul li {
+			position: relative;
+			top: -0.5rem;
+		}
+	}
+}
+
+body.has-picture nav::after {
+	background-color: $tertiary-color;
+	background-image: var(--page-picture);
+	background-size: $width;
+	background-position: top;
+}
+
+.gru-content {
+	div.textcell h2:first-child {
+		font-weight: 600;
+	}
+	// focus style for combo cells
+	div.cell.focus {
+		background: $tertiary-color;
+		padding: 40px;
+	}
+}
+
+div#footer-wrapper {
+	background: url(img/footer-fond.png) no-repeat center 0 $footer-background;
+	div.no-mobile {
+		@media screen and (max-width: $nav-mobile-limit) {
+			display: none;
+		}
+	}
+	div.textcell {
+		line-height: 1.2;
+		a {
+			color: $footer-color;
+			font-size: 14px;
+		}
+		a:hover {
+			text-decoration: underline;
+		}
+		div.horaires {
+			line-height: 1;
+			font-size: 18px;
+			a {
+				font-size: 18px;
+			}
+			h2 {
+				font-size: 22px;
+				font-weight: 800;
+				text-transform: none;
+				margin: 20px, 0, 0, 0;
+			}
+			p {
+				margin: 0;
+			}
+			color: black;
+			background: #ff5f21;
+			padding: 10px 20px 20px 60px;
+			position: relative;
+			top: -10px;
+			width: 265px;
+		}
+		h2, h3 {
+			text-transform: uppercase;
+		}
+		h2 {
+			font-size: 15px;
+			font-weight: 300;
+			margin-bottom: 22px;
+		}
+		h3 {
+			font-size: 20px;
+			font-weight: 400;
+			margin: 0 0 0 0;
+		}
+		img {
+			display: block;
+			margin: 0 10px 10px 0;
+		}
+		img.marge {
+			margin: 0 0 20px 54px;
+		}
+		p {
+			margin-left: 0;
+		}
+		p a {
+			display: inline-block;
+			text-align: center;
+			font-size: 12px;
+		}
+		p.liens {
+			border-top: 1px solid #888;
+			border-bottom: 1px solid #888;
+			font-style: italic;
+			line-height: 1;
+			padding: 5px 0 0 54px;
+			margin: 20px 0 20px 0;
+			a {
+				text-align: left;
+				font-size: 16px;
+				display: block;
+				margin: 15px 0px 15px 0;
+			}
+		}
+		p.marge {
+			line-height: 1.5;
+			margin: 15px 0 20px 54px;
+			a.overgris {
+				font-family: "Noto Sans Condensed", sans-serif;
+				font-size: 20px;
+				font-weight: 100;
+				text-align: left;
+				white-space: nowrap;
+				em {
+					font-style: normal;
+				}
+			}
+		}
+		ul {
+			list-style: none;
+			margin-top: 0;
+			padding-left: 0;
+		}
+		ul#footer-ecrire li {
+			line-height: 1.5;
+			margin: 0 0 10px 54px;
+		}
+	}
+}
diff --git a/static/saint-denis/_vars.scss b/static/saint-denis/_vars.scss
new file mode 100644
index 00000000..bd6ffdc2
--- /dev/null
+++ b/static/saint-denis/_vars.scss
@@ -0,0 +1,29 @@
+$primary-color: #eb612d;
+$secondary-color: #f7b38c;
+$tertiary-color: #ecebe7;
+$link-color: #e32c0d;
+
+$font-family: "Noto Sans Semi Condensed", sans-serif;
+$font-color: #49494b;
+$font-size: 15px;
+
+$width: 1200px;
+
+$nav-background: $primary-color;
+$nav-color: #2e247a;
+$nav-active-color: $primary-color;
+$nav-font-size: 25px;
+$nav-after-image: true;
+$nav-after-image-height: 483px;
+$nav-submenu-color: $font-color;
+
+$footer-background: #494949;
+$footer-color: white;
+
+$title-color: $font-color;
+$title-font-size: 30px;
+$title-weight: 400;
+
+$cell-border: none;
+$button-background: $secondary-color;
+$button-hover-background: $primary-color;
diff --git a/static/saint-denis/config.json b/static/saint-denis/config.json
new file mode 100644
index 00000000..df441bd4
--- /dev/null
+++ b/static/saint-denis/config.json
@@ -0,0 +1,6 @@
+{
+  "label": "Saint-Denis",
+  "variables": {
+    "theme_color": "#eb612d"
+  }
+}
diff --git a/static/saint-denis/img/footer-fond.png b/static/saint-denis/img/footer-fond.png
new file mode 100644
index 0000000000000000000000000000000000000000..4bb123c036511cd13134117c0269bef08d421da7
GIT binary patch
diff --git a/static/saint-denis/img/logo-saint-denis.png b/static/saint-denis/img/logo-saint-denis.png
new file mode 100644
index 0000000000000000000000000000000000000000..3aee2b8889b417a0d5524869b36ae8ad00a4c091
GIT binary patch
diff --git a/static/saint-denis/style.scss b/static/saint-denis/style.scss
new file mode 100644
index 00000000..1fd447de
--- /dev/null
+++ b/static/saint-denis/style.scss
@@ -0,0 +1,5 @@
+@charset "UTF-8";
+
+@import 'vars';
+@import '../includes/publik';
+@import 'custom';
-- 
2.24.0